## trac 1.5.3+dfsg

=== Makefile ===
# == Makefile for Trac related tasks
#
# Automating testing, l10n tasks, documentation generation, ... see HELP below
# ----------------------------------------------------------------------------
#
# Note about customization:
#
#   No changes to the present Makefile should be necessary,
#   configuration should take place in the Makefile.cfg file.
#
#   Copy Makefile.cfg.sample to Makefile.cfg and adapt it
#   to match your local environment.
#
# Note that this is a GNU Makefile, nmake and other abominations are
# not supported. On Windows, you can use it from a msys2 shell, like
# the one that comes part of https://git-for-windows.github.io.
#
# ============================================================================

define HELP

 The Trac Makefile is here to help automate development and
 maintenance tasks.

 Please use `make <target>' where <target> is one of:

  clean               delete all compiled files
  status              show which Python is used and other infos

  [python=...]        variable for selecting Python version
  [pythonopts=...]    variable containing extra options for the interpreter

 As there are many more tasks available, you can ask for specific help:

  help-code           tasks for checking the code style
  help-testing        tasks and configuration parameters for testing
  help-server         tasks and configuration for starting tracd
  help-l10n           tasks and configuration for L10N maintenance
  help-doc            tasks and configuration for preparing Trac documentation
  help-release        tasks and configuration for preparing a Trac release
  help-misc           several other tasks

  help-all            all the tasks at a glance...
endef
# `
export HELP

define HELP_CFG
 It looks like you don't have a Makefile.cfg file yet.
 You can get started by doing `cp Makefile.cfg.sample Makefile.cfg'
 and then adapt it to your environment.
endef
export HELP_CFG

# ============================================================================

# ----------------------------------------------------------------------------
#
# Main targets
#
# ----------------------------------------------------------------------------

.PHONY: all help help-all status clean clean-bytecode clean-mo

%.py : status
	$(PYTHON) -m unittest $(testopts) $(subst /,.,$(@:.py=)).test_suite

ifdef test
all: status
	$(PYTHON) -m unittest $(testopts) $(subst /,.,$(test:.py=)).test_suite
else
all: help
endif

help: Makefile.cfg
	@echo "$$HELP"

help_variables = $(filter HELP_%,$(.VARIABLES))
help_targets = $(filter-out help-CFG,$(help_variables:HELP_%=help-%))

.SECONDEXPANSION:
help-all: $$(sort $$(help_targets))


help-%: Makefile.cfg
	@echo "$${HELP_$*}"

Makefile.cfg:
	@echo "$$HELP_CFG"

status:
	@echo
	@echo "Python: $$(which $(PYTHON)) $(pythonopts)"
	@echo
	@$(PYTHON) contrib/make_status.py
	@echo
	@echo "Variables:"
	@echo "  PATH=$$PATH"
	@echo "  PYTHONPATH=$$PYTHONPATH"
	@echo "  TRAC_TEST_DB_URI=$$TRAC_TEST_DB_URI"
	@echo "  server-options=$(server-options)"
	@echo
	@echo "External dependencies:"
	@printf "  Git version: "
	@git --version 2>/dev/null || echo "not installed"
	@printf "  Subversion version: "
	@svn --version -q 2>/dev/null || echo "not installed"
	@echo

Trac.egg-info: status
	$(PYTHON) setup.py egg_info

clean: clean-bytecode clean-coverage clean-doc

clean-bytecode:
	find . -name \*.py[co] -exec rm {} \;

Makefile: ;

# ----------------------------------------------------------------------------
#
# Copy Makefile.cfg.sample to Makefile.cfg and adapt to your local
# environment, no customization of the present Makefile should be
# necessary.
#
#
-include Makefile.cfg
#
# ----------------------------------------------------------------------------


# ----------------------------------------------------------------------------
#
# L10N related tasks
#
# ----------------------------------------------------------------------------

define HELP_l10n

 ---------------- L10N tasks

  init-xy             create catalogs for given xy locale

  extraction          regenerate the catalog templates

  update              update all the catalog files from the templates
  update-xy           update the catalogs for the xy locale only
  [updateopts=...]    variable containing extra options for update (e.g. -N)

  compile             compile all the catalog files
  compile-xy          compile the catalogs for the xy locale only

  check               verify all the catalog files
  check-xy            verify the catalogs for the xy locale only

  stats               detailed translation statistics for all catalogs
  stats-pot           total messages in the catalog templates
  stats-xy            translated, fuzzy, untranslated for the xy locale only

  summary             display percent translated for all catalogs
  summary-xy          display percent translated for the xy locale only
                      (suitable for a commit message)

  tx-merge            merge catalogs from Transifex for all locales
  tx-merge-xy         merge catalogs from Transifex for the xy locale only

  xdiff               show changes to message strings for all catalogs
  xdiff-pot           show changes to message strings in the catalog template
  xdiff-xy            show changes to message strings for the xy locale

  diff                show summarized changes after an update for all catalogs
  diff-xy             show summarized changes after an update for the xy locale
  [vc=...]            variable containing the version control command to use

  [locale=...]        variable for selecting a set of locales

endef
export HELP_l10n

catalogs = messages messages-js tracini

ifdef locale
    locales = $(locale)
else
    locales = $(wildcard trac/locale/*/LC_MESSAGES/messages.po)
    locales := $(subst trac/locale/,,$(locales))
    locales := $(subst /LC_MESSAGES/messages.po,,$(locales))
    locales := $(sort $(locales))
endif

# Note: variables only valid within a $(foreach catalog,...) evaluation
catalog.po = trac/locale/$(*)/LC_MESSAGES/$(catalog).po
catalog.pot = trac/locale/$(catalog).pot
catalog_stripped = $(subst messages,,$(subst -,,$(catalog)))
_catalog = $(if $(catalog_stripped),_)$(catalog_stripped)

.PHONY: extract extraction update compile check stats summary diff


init-%:
	@$(foreach catalog,$(catalogs), \
	    [ -e $(catalog.po) ] \
	    && echo "$(catalog.po) already exists" \
	    || $(PYTHON) setup.py init_catalog$(_catalog) -l $(*);)


extract extraction:
	$(PYTHON) setup.py $(foreach catalog,$(catalogs),\
	    extract_messages$(_catalog))


update-%:
	$(PYTHON) setup.py $(foreach catalog,$(catalogs), \
	    update_catalog$(_catalog) -l $(*)) $(updateopts)

ifdef locale
update: $(addprefix update-,$(locale))
else
update:
	$(PYTHON) setup.py $(foreach catalog,$(catalogs), \
	    update_catalog$(_catalog)) $(updateopts)
endif


compile-%:
	$(PYTHON) setup.py $(foreach catalog,$(catalogs), \
	    compile_catalog$(_catalog) -l $(*)) \
	    generate_messages_js -l $(*)

ifdef locale
compile: $(addprefix compile-,$(locale))
else
compile:
	$(PYTHON) setup.py $(foreach catalog,$(catalogs), \
	    compile_catalog$(_catalog)) generate_messages_js
endif


check: pre-check $(addprefix check-,$(locales))
	@echo "All catalogs checked are OK"

pre-check:
	@echo "checking catalogs for $(locales)..."

check-%:
	@printf "$(@): "
	$(PYTHON) setup.py $(foreach catalog,$(catalogs), \
	    check_catalog$(_catalog) -l $(*))
	@$(foreach catalog,$(catalogs), \
	    msgfmt --check $(catalog.po) &&) echo msgfmt OK
	@rm -f messages.mo


stats: pre-stats $(addprefix stats-,$(locales))

pre-stats: stats-pot
	@echo "translation statistics for $(locales)..."

stats-pot:
	@echo "translation statistics for catalog templates:"
	@$(foreach catalog,$(catalogs), \
	    printf "$(catalog.pot): "; \
	    msgfmt --statistics $(catalog.pot);)
	@rm -f messages.mo

stats-%:
	@$(foreach catalog,$(catalogs), \
	    [ -e $(catalog.po) ] \
	    && { printf "$(catalog.po): "; \
	         msgfmt --statistics $(catalog.po); } \
	    || echo "$(catalog.po) doesn't exist (make init-$(*))";)
	@rm -f messages.mo


summary: $(addprefix summary-,$(locales))

define untranslated-sh
LC_ALL=C msgfmt --statistics $(catalog.pot) 2>&1 \
  | tail -1 \
  | sed -e 's/0 translated messages, \([0-9]*\) un.*/\1/'
endef

define translated-sh
{ LC_ALL=C msgfmt --statistics $(catalog.po) 2>&1 || echo 0; } \
    | tail -1 \
    | sed -e 's/[^0-9]*\([0-9]*\) translated.*/\1/'
endef

MESSAGES_TOTAL = \
    $(eval MESSAGES_TOTAL := ($(foreach catalog,$(catalogs), \
                                  $(shell $(untranslated-sh)) + ) 0)) \
    $(MESSAGES_TOTAL)

summary-%:
	@$(PYTHON) -c "print('l10n/$(*): translations updated (%d%%)' \
	    % (($(foreach catalog,$(catalogs), \
	          $(shell $(translated-sh)) + ) 0) * 100.0 \
	       / $(MESSAGES_TOTAL)))"
	@rm -f messages.mo


tx-merge-%:
	@$(foreach catalog,$(catalogs), \
	    touch $(catalog.po); \
	    mv $(catalog.po) $(catalog.po).orig; \
	)
	@tx pull --force --no-interactive -l $(*)
	@$(foreach catalog,$(catalogs), \
	    [ -f $(catalog.po) ] && mv $(catalog.po) $(catalog.po).tx; \
	    mv $(catalog.po).orig $(catalog.po); \
	    [ -f $(catalog.po).tx ] && { \
	        $(PYTHON) contrib/merge_catalog.py $(catalog) $(catalog.po).tx $(*); \
	        rm $(catalog.po).tx; \
	    }; \
	)

tx-merge: $(addprefix tx-merge-,$(filter-out en_US,$(locales)))


diff: $(addprefix diff-,$(locales))

ifndef vc
ifneq "$(wildcard $(CURDIR)/.svn)" ""
    vc := svn
else ifneq "$(wildcard $(CURDIR)/.git)" ""
    vc := git
else ifneq "$(wildcard $(CURDIR)/.hg)" ""
    vc := hg
endif
endif

define vc_cat-svn
    $(vc) cat -rBASE $(1)
endef
define vc_cat-git
    $(vc) show HEAD:$(1)
endef
define vc_cat-hg
    $(vc) cat -r. $(1)
endef
define vc_cat
    $(call vc_cat-$(vc),$(1))
endef

define xdiff_catalog
    { \
        $(call vc_cat,$(1)) \
            | msgcat --no-wrap --no-location -s -i - >$(1).tmp; \
        msgcat --no-wrap --no-location -s -i - <$(1) \
            | diff -u -L $(1) -L $(1) $(1).tmp - || :; \
        rm -- $(1).tmp; \
    }
endef


xdiff-pot:
	@$(foreach catalog,$(catalogs), \
	    $(call xdiff_catalog,$(catalog.pot)); \
	)

xdiff-%:
	@$(foreach catalog,$(catalogs), \
	    $(call xdiff_catalog,$(catalog.po)); \
	)

xdiff: $(addprefix xdiff-,$(locales))

diff-%:
	@diff=l10n-$(*).diff; \
	$(vc) diff trac/locale/$(*) > $$diff; \
	[ -s $$diff ] && { \
	    printf "# $(*) changed -> "; \
	    $(PYTHON) contrib/l10n_diff_index.py $$diff; \
	} || rm $$diff

# The above creates l10n-xy.diff files but also a l10n-xy.diff.index
# file pointing to "interesting" diffs (message changes or addition
# for valid msgid).
#
# See also contrib/l10n_sanitize_diffs.py, which removes in-file
# *conflicts* for line change only.

clean-mo:
	find trac/locale -name \*.mo -exec rm {} \;
	find trac/htdocs/js/messages -name \*.js -exec rm {} \;


# ----------------------------------------------------------------------------
#
# Code checking tasks
#
# ----------------------------------------------------------------------------

define HELP_code

 ---------------- Code checking tasks

  pylint              check code with pylint
  jinja               check Jinja2 templates
  coffee              compile .coffee script files into .js files

  [module=...]        module or package to check with pylint
  [templates=...]     list of Jinja2 templates to check
  [coffeescripts=...] list of coffee script files to compile
  [jinjaopts=]        list of options for jinja checker

endef
export HELP_code

.PHONY: pylint jinja coffee

pylintopts = --persistent=n --init-import=y \
--disable=E0102,E0211,E0213,E0602,E0611,E1002,E1101,E1102,E1103 \
--disable=F0401 \
--disable=W0102,W0141,W0142,W0201,W0212,W0221,W0223,W0231,W0232, \
--disable=W0401,W0511,W0603,W0613,W0614,W0621,W0622,W0703 \
--disable=C0103,C0111 \

ifdef module
pylint:
	pylint $(pylintopts) $(subst /,.,$(module:.py=))
else
pylint:

=== debian/changelog ===
trac (1.5.3+dfsg-1ubuntu0.1) jammy; urgency=medium

  * Fix crash on startup (LP: #2024325)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 29 Jan 2024 21:16:53 +0000

trac (1.5.3+dfsg-1) unstable; urgency=medium

  * Development maintenance release:
    - (May 9, 2021) Fixed several regressions and compatibility issues
      in the Python 3 conversion.
      https://trac.edgewall.org/wiki/1.5/TracChangeLog#a1.5.3

 -- Martin <debacle@debian.org>  Mon, 10 May 2021 08:13:27 +0000

=== debian/control ===
Source: trac
Section: web
Priority: optional
Build-Depends: debhelper-compat (= 11)
Build-Depends-Indep: dh-python,
                     git,
                     python3,
                     python3-babel,
                     python3-docutils,
                     python3-jinja2,
                     python3-lxml,
                     python3-pygments,
                     python3-selenium,
                     python3-setuptools,
                     python3-subversion,
                     python3-textile,
                     python3-tidylib,
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Martin <debacle@debian.org>,
           Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Standards-Version: 4.1.3
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/python-team/packages/trac
Vcs-Git: https://salsa.debian.org/python-team/packages/trac.git
Homepage: http://trac.edgewall.com

Package: trac
Architecture: all
Depends: libjs-excanvas,
         libjs-jquery,
         libjs-jquery-ui,
         libjs-jquery-timepicker,
         python3-jinja2,
         python3-setuptools,
         ${misc:Depends},
         ${python3:Depends}
Recommends: apache2 | httpd,
            python3-babel,
            python3-docutils,
            python3-pygments,
            python3-subversion,
            python3-tz
Suggests: libapache2-mod-wsgi,
          python3-psycopg2,
          python3-textile,
          trac-accountmanager,
          trac-authopenid,
          trac-bitten,
          trac-bzr (>= 0.2+bzr45),
          trac-customfieldadmin,
          trac-email2trac,
          trac-graphviz,
          trac-ja-resource,
          trac-mastertickets,
          trac-mercurial (>= 0.11.0.4),
          trac-spamfilter,
          trac-wikiprint,
          trac-wikirename,
          trac-wysiwyg,
          trac-xmlrpc
Description: Enhanced wiki and issue tracking system for software development projects
 Trac uses a minimalistic approach to web-based software project management.
 Its mission is to help developers write great software while staying out of
 the way. Trac should impose as little as possible on a team's established
 development process and policies.
 It provides an interface to Subversion (or other version control systems),
 an integrated Wiki and convenient reporting facilities.
 Trac allows wiki markup in issue descriptions and commit messages, creating
 links and seamless references between bugs, tasks, changesets, files and
 wiki pages. A timeline shows all current and past project events in order,
 making the acquisition of an overview of the project and tracking progress
 very easy. The roadmap shows the road ahead, listing the upcoming milestones.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python3 --buildsystem=pybuild

# temporarily ignore test errors
override_dh_auto_test:
	dh_auto_test || true

# do not install test result
override_dh_auto_install:
	rm -rf ./.pybuild/cpython3_3.9/build/trac_convert_db_*/
	dh_auto_install

## trac 1.5.4

=== .github/requirements.txt ===
Jinja2
selenium
pytidylib
Babel<2.10
Pygments
docutils
textile
pytz
PyMySQL
cryptography
psycopg2
passlib; python_version>='3.13' or python_version<'3.7' or platform_system=='Darwin' or platform_system=='Windows'
bcrypt; python_version>='3.13' or python_version<'3.7' or platform_system=='Darwin' or platform_system=='Windows'

=== debian/changelog ===
trac (1.5.4-1) unstable; urgency=medium

  * Development maintenance release:
    - (Feb 11, 2023) Fixed several compatibility issues with Python 3
      releases and Jinja2.
      https://trac.edgewall.org/wiki/1.5/TracChangeLog#a1.5.4
      (Closes: #1030413)

 -- Martin <debacle@debian.org>  Mon, 13 Feb 2023 12:18:55 +0000

## trac 1.6

=== Makefile ===
--- 
+++ 
@@ -305,7 +305,7 @@
 	    touch $(catalog.po); \
 	    mv $(catalog.po) $(catalog.po).orig; \
 	)
-	@tx pull --force --no-interactive -l $(*)
+	@tx pull --force --silent -l $(*)
 	@$(foreach catalog,$(catalogs), \
 	    [ -f $(catalog.po) ] && mv $(catalog.po) $(catalog.po).tx; \
 	    mv $(catalog.po).orig $(catalog.po); \

=== .github/requirements.txt ===
Jinja2
multipart; python_version>='3.11'
aiosmtpd; python_version>='3.10'
selenium!=4.10.0
pytidylib
Babel<2.10
Pygments
docutils
textile
pytz
PyMySQL
cryptography
psycopg2
passlib; python_version>='3.11' or python_version<'3.7' or platform_system=='Darwin' or platform_system=='Windows'
bcrypt; python_version>='3.11' or python_version<'3.7' or platform_system=='Darwin' or platform_system=='Windows'

=== debian/changelog ===
trac (1.6-4) unstable; urgency=medium

  * Team upload.
  * Replace dependency on transitional python3-tz with new python3-pytz
  * Use dh-sequence-python3
  * Drop "Rules-Requires-Root: no": it is now the default

 -- Alexandre Detiste <tchet@debian.org>  Sun, 16 Nov 2025 16:08:39 +0100

trac (1.6-3) unstable; urgency=medium

  * Team upload.
  * (Build-)depend on python3-multipart, needed for Python 3.13 (closes:
    #1082321).

 -- Colin Watson <cjwatson@debian.org>  Tue, 24 Dec 2024 11:02:54 +0000

trac (1.6-2) unstable; urgency=medium

  * bump debhelper-compat to 13
  * drop obsolete artefact deletion in debian/rules

 -- Martin <debacle@debian.org>  Sun, 19 Nov 2023 15:56:54 +0000

trac (1.6-1) unstable; urgency=medium

  * New upstream version (Closes: #988462)

 -- Martin <debacle@debian.org>  Thu, 28 Sep 2023 07:45:26 +0000

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,25 @@
 Source: trac
 Section: web
 Priority: optional
-Build-Depends: debhelper-compat (= 11)
-Build-Depends-Indep: dh-python,
+Build-Depends: debhelper-compat (= 13)
+Build-Depends-Indep: dh-sequence-python3,
                      git,
                      python3,
                      python3-babel,
                      python3-docutils,
                      python3-jinja2,
                      python3-lxml,
+                     python3-multipart,
                      python3-pygments,
                      python3-selenium,
                      python3-setuptools,
                      python3-subversion,
                      python3-textile,
                      python3-tidylib,
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Python Team <team+python@tracker.debian.org>
+Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: Martin <debacle@debian.org>,
            Daniel Kahn Gillmor <dkg@fifthhorseman.net>
 Standards-Version: 4.1.3
-Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/python-team/packages/trac
 Vcs-Git: https://salsa.debian.org/python-team/packages/trac.git
 Homepage: http://trac.edgewall.com
@@ -39,8 +38,8 @@
             python3-babel,
             python3-docutils,
             python3-pygments,
+            python3-pytz,
             python3-subversion,
-            python3-tz
 Suggests: libapache2-mod-wsgi,
           python3-psycopg2,
           python3-textile,

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=pybuild

# temporarily ignore test errors
override_dh_auto_test:
	dh_auto_test || true
